## ros-dashing-class-loader 1.3.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(class_loader)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
endif()

find_package(console_bridge_vendor REQUIRED) # Provides console_bridge 0.4.0 on platforms without it.
find_package(console_bridge REQUIRED)
find_package(poco_vendor REQUIRED)  # Provides FindPoco.cmake and Poco on platforms without it.
find_package(Poco REQUIRED COMPONENTS Foundation)
link_directories(${Poco_LIBRARY_DIR})

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_include_directories(include)
endif()

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS})
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}
    PUBLIC include)
  ament_target_dependencies(${PROJECT_NAME} "console_bridge" "Poco")
  ament_export_libraries(${PROJECT_NAME})
else()
  target_include_directories(${PROJECT_NAME}
    PUBLIC include ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
endif()
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto QUIET)
  if(ament_lint_auto_FOUND)
    # TODO(mikaelarguedas) add copyright test once the linter accepts /** block comments
    list(APPEND AMENT_LINT_AUTO_EXCLUDE
      ament_cmake_copyright
    )
    ament_lint_auto_find_test_dependencies()

    # Files in test/fviz_case_study do have compatible copyrights
    find_package(ament_cmake_copyright)
    ament_copyright(
      TESTNAME copyright_check_tests_only
      "test/fviz_case_study"
    )
  endif()
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
    ${Poco_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION include)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

include("../cmake/class_loader_hide_library_symbols.cmake")

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL SHARED plugins1.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_TestPlugins1
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_TestPlugins1 "console_bridge" "Poco")
else()
  target_include_directories(${PROJECT_NAME}_TestPlugins1
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)

add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL SHARED plugins2.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_TestPlugins2
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_TestPlugins2 "console_bridge" "Poco")
else()
  target_include_directories(${PROJECT_NAME}_TestPlugins2
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_utest utest.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)

if(TARGET ${PROJECT_NAME}_utest)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_utest "console_bridge" "Poco")
  else()
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_utest ${Poco_LIBRARIES})
  endif()
  target_link_libraries(${PROJECT_NAME}_utest ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_utest pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_utest
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2)
endif()

ament_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_unique_ptr_test)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_unique_ptr_test "Poco")
  else()
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include" ${Poco_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${Poco_LIBRARIES})
  endif()
  target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_unique_ptr_test
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2)
endif()

add_subdirectory(fviz_case_study)

=== test/fviz_case_study/CMakeLists.txt ===
add_library(${PROJECT_NAME}_Test_Fviz EXCLUDE_FROM_ALL SHARED fviz.cpp)
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME}_Test_Fviz PRIVATE "FVIZ_BUILDING_DLL")
endif()

# This "fviz_main" is just for testing locally, for the test see "fviz_test" below.
add_executable(${PROJECT_NAME}_Test_Fviz_Main EXCLUDE_FROM_ALL fviz_main.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_Test_Fviz_Main
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_Test_Fviz_Main "console_bridge" "Poco")
else()
  target_include_directories(${PROJECT_NAME}_Test_Fviz_Main
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_Test_Fviz_Main
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)

add_library(${PROJECT_NAME}_Test_FvizDefaultPlugin
  EXCLUDE_FROM_ALL SHARED fviz_default_plugin.cpp)
target_include_directories(${PROJECT_NAME}_Test_FvizDefaultPlugin
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_Test_FvizDefaultPlugin
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
class_loader_hide_library_symbols(${PROJECT_NAME}_Test_FvizDefaultPlugin)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_fviz_test fviz_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_fviz_test)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_fviz_test
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_fviz_test "console_bridge" "Poco")
  else()
    target_include_directories(${PROJECT_NAME}_fviz_test
      PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_fviz_test ${Poco_LIBRARIES})
  endif()
  target_link_libraries(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_fviz_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME}_Test_FvizDefaultPlugin ${PROJECT_NAME}_Test_Fviz_Main)
endif()

=== debian/changelog ===
ros-dashing-class-loader (1.3.3-1bionic) bionic; urgency=high

  * Use .empty() to check for an empty string. (#132 <https://github.com/ros/class_loader/issues/132>)
  * Fix travis on macOS. (#135 <https://github.com/ros/class_loader/issues/135>)
  * Contributors: Chris Lalancette

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 13 Mar 2020 04:00:00 -0000

ros-dashing-class-loader (1.3.2-1bionic) bionic; urgency=high

  * Correctly export class_loader library (#129 <https://github.com/ros/class_loader/pull/129>)
  * Contributors: Shane Loretz

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 30 Jul 2019 04:00:00 -0000

ros-dashing-class-loader (1.3.0-1bionic) bionic; urgency=high

  * Updated test configuration to check copyright of files where possible. (#123 <https://github.com/ros/class_loader/issues/123>)
  * Updated to use ament_target_dependencies where possible. (#121 <https://github.com/ros/class_loader/issues/121>)
  * Contributors: ivanpauno, jpsamper2009

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 12 Apr 2019 04:00:00 -0000

ros-dashing-class-loader (1.2.0-1bionic) bionic; urgency=high

  * Updated maintainer to Steven! Ragnarok the maintainer (#107 <https://github.com/ros/class_loader/issues/107>)
  * Added free impl_ in AbstractMetaObjectBase destructor (#103 <https://github.com/ros/class_loader/issues/103>)
  * Overhauled CI.u (#106 <https://github.com/ros/class_loader/issues/106>)
  * Fixed spacing to comply with uncrusity 0.67 (#99 <https://github.com/ros/class_loader/issues/99>)
  * Updated to use console_bridge_vendor (#98 <https://github.com/ros/class_loader/issues/98>)
  * Contributors: Chris Ye, Mikael Arguedas

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 16 Nov 2018 05:00:00 -0000

ros-dashing-class-loader (0.3.2-1bionic) bionic; urgency=high

  * Fixed wrong handling of false statement (pkg-config was not installed)
  * Make catkin optional again
  * Contributors: Esteve Fernandez, Janosch Machowinski, Matthias Goldhoorn

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 22 Apr 2015 04:00:00 -0000

ros-dashing-class-loader (0.3.1-1bionic) bionic; urgency=high

  * Depend on boost
  * Use FindPoco.cmake from ros/cmake_modules
  * Honor BUILD_SHARED_LIBS and do not force building shared libraries.
  * Contributors: Esteve Fernandez, Gary Servin, Scott K Logan

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 23 Dec 2014 05:00:00 -0000

ros-dashing-class-loader (0.3.0-1bionic) bionic; urgency=high

  * Use system-provided console-bridge
  * Contributors: Esteve Fernandez

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 25 Jun 2014 04:00:00 -0000

ros-dashing-class-loader (0.2.5-1bionic) bionic; urgency=high

  * Changed format of debug messages so that rosconsole_bridge can correctly parse the prefix
  * Improved debug output

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 04 Mar 2014 05:00:00 -0000

ros-dashing-class-loader (0.2.4-1bionic) bionic; urgency=high

  * fix race condition with multi threaded library loading (#16 <https://github.com/ros/class_loader/issues/16>)

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 12 Feb 2014 05:00:00 -0000

ros-dashing-class-loader (0.2.3-1bionic) bionic; urgency=high

  * fix missing class name in logWarn output

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 21 Aug 2013 04:00:00 -0000

ros-dashing-class-loader (0.2.2-1bionic) bionic; urgency=high

  * check for CATKIN_ENABLE_TESTING (#10 <https://github.com/ros/class_loader/issues/10>)
  * fix find Poco to return full lib path (#8 <https://github.com/ros/class_loader/issues/8>)
  * add missing runtime destination for library under Windows
  * add Boosst component system

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Sun, 14 Jul 2013 04:00:00 -0000

ros-dashing-class-loader (0.2.1-1bionic) bionic; urgency=high

  * improve check for Poco foundation and headers (#7 <https://github.com/ros/class_loader/issues/7>)

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 06 Jun 2013 04:00:00 -0000

ros-dashing-class-loader (0.2.0-1bionic) bionic; urgency=high

  * use find_package for Poco/dl instead to make it work on other platforms
  * update Poco cmake file to include libdl on non-windows systems
  * No longer CATKIN_DEPEND on console_bridge

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 13 Mar 2013 04:00:00 -0000

ros-dashing-class-loader (0.1.27-1bionic) bionic; urgency=high

  * change warning message for managed/unmanaged instance mixture in lazy loading mode

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Fri, 25 Jan 2013 05:00:00 -0000

ros-dashing-class-loader (0.1.26-1bionic) bionic; urgency=high

  * fix all instances marked as unmanaged

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 17 Jan 2013 05:00:00 -0000

ros-dashing-class-loader (0.1.25-1bionic) bionic; urgency=high

  * fix redundant destructor definition being pulled into plugin library for metaobjects instead of being contained with libclass_loader.so

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 16 Jan 2013 05:00:00 -0000

ros-dashing-class-loader (0.1.24-1bionic) bionic; urgency=high

  * fix syntax error for logInform

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Mon, 14 Jan 2013 20:27:00 -0000

ros-dashing-class-loader (0.1.23-1bionic) bionic; urgency=high

  * downgrade some warning messages to be info/debug

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Mon, 14 Jan 2013 20:23:00 -0000

ros-dashing-class-loader (0.1.22-1bionic) bionic; urgency=high

  * add safety checks for mixing of managed/unmanaged mixing as well as pointer equivalency check between graveyard and newly created metaobjects

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Mon, 14 Jan 2013 20:01:00 -0000

ros-dashing-class-loader (0.1.21-1bionic) bionic; urgency=high



=== debian/control ===
Source: ros-dashing-class-loader
Section: misc
Priority: optional
Maintainer: Steven! Ragnarök <stevenragnarok@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libconsole-bridge-dev, libpoco-dev, ros-dashing-ament-cmake, ros-dashing-ament-cmake-gtest, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-console-bridge-vendor, ros-dashing-poco-vendor, ros-dashing-ros-workspace
Homepage: http://ros.org/wiki/class_loader
Standards-Version: 3.9.2

Package: ros-dashing-class-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libconsole-bridge-dev, libpoco-dev, ros-dashing-console-bridge-vendor, ros-dashing-poco-vendor, ros-dashing-ros-workspace
Description: The class_loader package is a ROS-independent package for loading plugins during runtime and the foundation of the higher level ROS &quot;pluginlib&quot; library.
 class_loader utilizes the host operating system's runtime loader to open runtime libraries (e.g. .so/.dll files), introspect the library for exported plugin classes, and allows users to instantiate objects of these exported classes without the explicit declaration (i.e. header file) for those classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-class-loader//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
